#include "localnetwork.h"
#include "networkconnectivitycheck.h"
#include "licensemodel.h"
#include "easylogging++.h"

#include <unistd.h>

static const QString UnionTechHostName = "http://detect.uniontech.com";

// using namespace dde::network;

bool Network::checkLocalNetwork()
{
    NetworkConnectivityCheck networkCheck(this);
    int unionTechStatus = -1;

    if (!networkCheck.getIsEnter())
        unionTechStatus = networkCheck.getNetworkStatus(UnionTechHostName);

    if (CheckNetworkState::NetworkNormal == unionTechStatus)
        return true;

    //m_dockNetworkStatus = deviceStateChanged("");

    if (m_dockNetworkStatus.compare("Activated") == 0) {
        LOG(INFO) << "Local network connection:" << m_dockNetworkStatus;

        if ((CheckNetworkState::NetworkConnectionTimeout == unionTechStatus) || (networkCheck.getNetWorkInterfaceStatus()))
            return true;
    }

    LOG(INFO) << "Current local network exception.";
    return false;
}

Network::Network(QObject *parent)
    : QObject(parent)
{
    init();
}

Network::~Network()
{
//    if (!m_wirelessItems.isEmpty()) {
//        for (auto iterator = m_wirelessItems.begin(); iterator != m_wirelessItems.end();) {
//            iterator.value()->deleteLater();
//            iterator.value() = nullptr;
//            m_wirelessItems.erase(iterator++);
//        }
//    }

//    if (!m_wiredItems.isEmpty()) {
//        for (auto iterator = m_wiredItems.begin(); iterator != m_wiredItems.end();) {
//            iterator.value()->deleteLater();
//            iterator.value() = nullptr;
//            m_wiredItems.erase(iterator++);
//        }
//    }

//    if (m_networkModel) {
//        delete m_networkModel;
//        m_networkModel = Q_NULLPTR;
//    }

//    if (m_networkWorker) {
//        delete m_networkWorker;
//        m_networkWorker = Q_NULLPTR;
//    }
}

void Network::init()
{
    int old = dup(1);

    if (old == -1) {
        LOG(INFO) << "dup fail.";
        exit(1);
    }

    FILE *fp = freopen("/dev/null", "w", stdout);

    if (fp == nullptr) {
        LOG(INFO) << "freopen error!";
        exit(1);
    }

//    m_networkModel = new NetworkModel;
//    m_networkWorker = new NetworkWorker(m_networkModel);

    fflush(stdout); //将输出缓冲区清空
    dup2(old, 1); //恢复标准输出文件描述符

//    connect(m_networkModel, &NetworkModel::deviceListChanged, this, &Network::onDeviceListChanged);
//    onDeviceListChanged(m_networkModel->devices());
}

//void Network::onDeviceListChanged(const QList<NetworkDevice *> devices)
//{
//    for (auto device : devices) {
//        const QString &path = device->path();
//        NetworkDevice *networkDevice = nullptr;
//        switch (device->status()) {
//            case dde::network::NetworkDevice::DeviceStatus::Unknown:
//                m_dockNetworkStatus = "Unknown";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Unmanaged:
//                m_dockNetworkStatus = "Unmanaged";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Unavailable:
//                m_dockNetworkStatus = "Unavailable";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Disconnected:
//                m_dockNetworkStatus = "Disconnected";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Prepare:
//                m_dockNetworkStatus = "Prepare";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Config:
//                m_dockNetworkStatus = "Config";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::NeedAuth:
//                m_dockNetworkStatus = "NeedAuth";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::IpConfig:
//                m_dockNetworkStatus = "IpConfig";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::IpCheck:
//                m_dockNetworkStatus = "IpCheck";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Secondaries:
//                m_dockNetworkStatus = "Secondaries";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Activated:
//                m_dockNetworkStatus = "Activated";
//                return;

//            case dde::network::NetworkDevice::DeviceStatus::Deactivation:
//                m_dockNetworkStatus = "Deactivation";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Failed:
//                m_dockNetworkStatus = "Failed";
//                break;
//            default:
//                m_dockNetworkStatus = QString();
//                break;
//            }

//            switch (device->type()) {
//            case NetworkDevice::Wired:
//                networkDevice = device;
//                m_wiredItems.insert(path, networkDevice);
//                connect(networkDevice, static_cast<void (NetworkDevice::*)(const QString &statStr) const>(&NetworkDevice::statusChanged), this, &Network::deviceStateChanged);
//                break;

//            case NetworkDevice::Wireless:
//                networkDevice = device;
//                m_wirelessItems.insert(path, networkDevice);
//                connect(networkDevice, static_cast<void (NetworkDevice::*)(const QString &statStr) const>(&NetworkDevice::statusChanged), this, &Network::deviceStateChanged);
//                break;
//            default:
//                break;
//        }
//    }
//}
//QString Network::deviceStateChanged(const QString &state)
//{
//    Q_UNUSED(state);
//    auto devices = m_networkModel->devices();
//    for (auto device : devices) {
//        switch (device->status()) {
//            case dde::network::NetworkDevice::DeviceStatus::Unknown:
//                m_dockNetworkStatus = "Unknown";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Unmanaged:
//                m_dockNetworkStatus = "Unmanaged";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Unavailable:
//                m_dockNetworkStatus = "Unavailable";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Disconnected:
//                m_dockNetworkStatus = "Disconnected";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Prepare:
//                m_dockNetworkStatus = "Prepare";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Config:
//                m_dockNetworkStatus = "Config";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::NeedAuth:
//                m_dockNetworkStatus = "NeedAuth";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::IpConfig:
//                m_dockNetworkStatus = "IpConfig";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::IpCheck:
//                m_dockNetworkStatus = "IpCheck";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Secondaries:
//                m_dockNetworkStatus = "Secondaries";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Activated:
//                m_dockNetworkStatus = "Activated";
//                return m_dockNetworkStatus;

//            case dde::network::NetworkDevice::DeviceStatus::Deactivation:
//                m_dockNetworkStatus = "Deactivation";
//                break;

//            case dde::network::NetworkDevice::DeviceStatus::Failed:
//                m_dockNetworkStatus = "Failed";
//                break;
//            default:
//                m_dockNetworkStatus = QString();
//                break;
//        }
//    }
//    return m_dockNetworkStatus;
//}
