#include "activatorwindow.h"
// #include "uihelper.h"
#include "localnetwork.h"
#include "licensemodel.h"
#include "widgets/status_widget.h"
// #include "../../agent/logencryption.h"

//#include <DLabel>
//#include <DMenu>
//#include <DFontSizeManager>
//#include <DDialog>
//#include <DThemeManager>s
//#include <DPushButton>
//#include <DWidgetUtil>
//#include <DStandardPaths>
//#include <DHiDPIHelper>
//#include <DTitlebar>
//#include <DApplication>
//#include <DSuggestButton>
//#include <dfilechooseredit.h>
//#include <DLineEdit>
//#include <DWindowOptionButton>

#include <QLabel>
#include <QMenu>
// #include <QFontSizeManager>
#include <QDialog>
// #include <QThemeManager>
#include <QPushButton>
// #include <QWidgetUtil>
#include <QStandardPaths>
// #include <QHiDPIHelper>
// #include <QTitlebar>
#include <QApplication>
// #include <QSuggestButton>
// #include <dfilechooseredit.h>
#include <QLineEdit>
// #include <QWindowOptionButton>

#include <QFileDialog>
#include <QDesktopServices>
#include <QMouseEvent>
#include <QDebug>
#include <QStack>
#include <QDate>
#include <QTimer>
#include <QPainter>
#include <QDBusInterface>
#include <QDBusReply>
#include <QScrollArea>

#include <QDesktopWidget>
#include <QObject>
#include <QEvent>
#include <iostream>

#include "widgets/offline-activated-widget.h"
#include "widgets/offline-qrcode-widget.h"
#include "widgets/offline-inline-widget.h"
#include "widgets/failed-widget.h"
#include "widgets/success-widget.h"
#include "uihelper.h"
#include "easylogging++.h"

// DWIDGET_USE_NAMESPACE
class ActivatorWindowPrivate
{
public:
    ActivatorWindowPrivate(ActivatorWindow *parent)
        : q_ptr(parent)
    {
    }

    void initUI();
    void initConnection();

    QWidget *recordWidget = Q_NULLPTR;
    ActivatorWindow *q_ptr;
    QScrollArea *unactivatedScrollArea;
    UnactivatedWidget *m_unactivatedWidget;

    QScrollArea *offlineQrcodeScrollArea;
    OfflineQrcodeWidget *m_offlineQrcodeWidget;

    QScrollArea *offlineActivatedScrollArea;
    OfflineActivatedWidget *m_offlineActivatedWidget;

    QScrollArea *offlineInlineScrollArea;
    OfflineInlineWidget *m_offlineInlineWidget;

    QScrollArea *successScrollArea;
    SuccessWidget *m_successWidget;

    QScrollArea *failedScrollArea;
    FailedWidget *m_failedWidget;

private:
    quint32 getNetworkStatus();

private:
    Q_DECLARE_PUBLIC(ActivatorWindow)
    Network *network = Q_NULLPTR;
};

ActivatorWindow::ActivatorWindow(QWidget *parent)
    : QMainWindow(parent)
    , dd_ptr(new ActivatorWindowPrivate(this))
{
    Q_D(ActivatorWindow);
    //
    this->setFixedSize(780,480);
    this->setWindowIcon(QIcon(":/icons/deepin/builtin/icons/logo.png"));
    Qt::WindowFlags flags = Qt::Window | Qt::WindowSystemMenuHint;
    flags |= Qt::FramelessWindowHint;

    setWindowFlags(flags);
    //
    m_operation = NoOperation;
    m_abortRequest = false;

    QWidget *wrapper = new QWidget(this);
    wrapper->setObjectName("mainWrapper");
    setAttribute(Qt::WA_TranslucentBackground);
    // title bar
    m_titlebar_widget = new TitleBarWidget(wrapper);
    connect(m_titlebar_widget, &TitleBarWidget::hideMainwindow, [ = ]() {
        this->hide();
    });
    m_titlebar_widget->installEventFilter(this);


    m_stackMainWindows = new QStackedWidget(wrapper);
    d->unactivatedScrollArea = new QScrollArea(m_stackMainWindows);
    d->unactivatedScrollArea->setGeometry(0, 0, 780, 444);
    d->unactivatedScrollArea->setFrameShape(QFrame::NoFrame);
    d->unactivatedScrollArea->setWidgetResizable(false);

    d->offlineQrcodeScrollArea = new QScrollArea(m_stackMainWindows);
    d->offlineQrcodeScrollArea->setGeometry(0, 0, 780, 444);
    d->offlineQrcodeScrollArea->setFrameShape(QFrame::NoFrame);
    d->offlineQrcodeScrollArea->setWidgetResizable(false);

    d->offlineActivatedScrollArea = new QScrollArea(m_stackMainWindows);
    d->offlineActivatedScrollArea->setGeometry(0, 0, 780, 444);
    d->offlineActivatedScrollArea->setFrameShape(QFrame::NoFrame);
    d->offlineActivatedScrollArea->setWidgetResizable(false);

    d->offlineInlineScrollArea = new QScrollArea(m_stackMainWindows);
    d->offlineInlineScrollArea->setGeometry(0, 0, 780, 444);
    d->offlineInlineScrollArea->setFrameShape(QFrame::NoFrame);
    d->offlineInlineScrollArea->setWidgetResizable(false);

    d->successScrollArea = new QScrollArea(m_stackMainWindows);
    d->successScrollArea->setGeometry(0, 0, 780, 444);
    d->successScrollArea->setFrameShape(QFrame::NoFrame);
    d->successScrollArea->setWidgetResizable(false);

    d->offlineInlineScrollArea = new QScrollArea(m_stackMainWindows);
    d->offlineInlineScrollArea->setGeometry(0, 0, 780, 444);
    d->offlineInlineScrollArea->setFrameShape(QFrame::NoFrame);
    d->offlineInlineScrollArea->setWidgetResizable(false);


    d->successScrollArea = new QScrollArea(m_stackMainWindows);
    d->successScrollArea->setGeometry(0, 0, 780, 444);
    d->successScrollArea->setFrameShape(QFrame::NoFrame);
    d->successScrollArea->setWidgetResizable(false);

    d->failedScrollArea = new QScrollArea(m_stackMainWindows);
    d->failedScrollArea->setGeometry(0, 0, 780, 444);
    d->failedScrollArea->setFrameShape(QFrame::NoFrame);
    d->failedScrollArea->setWidgetResizable(false);

//    d->inputOfflineSerialScrollArea = new QScrollArea(this);
//    d->inputOfflineSerialScrollArea->setGeometry(5, 20, 780, 480);
//    d->inputOfflineSerialScrollArea->setFrameShape(QFrame::NoFrame);
//    d->inputOfflineSerialScrollArea->setWidgetResizable(true);

//    d->tryFullVersionScrollArea = new QScrollArea(this);
//    d->tryFullVersionScrollArea->setGeometry(5, 20, 780, 480);
//    d->tryFullVersionScrollArea->setFrameShape(QFrame::NoFrame);
//    d->tryFullVersionScrollArea->setWidgetResizable(true);

//    d->importFileScrollArea = new QScrollArea(this);
//    d->importFileScrollArea->setGeometry(5, 20, 780, 480);
//    d->importFileScrollArea->setFrameShape(QFrame::NoFrame);
//    d->importFileScrollArea->setWidgetResizable(true);

//    d->activateDetailsScrollArea = new QScrollArea(this);
//    d->activateDetailsScrollArea->setFrameShape(QFrame::NoFrame);
//    d->activateDetailsScrollArea->setWidgetResizable(true);
//    d->activateDetailsScrollArea->setGeometry(5, 20, 780, 480);

    QVBoxLayout *layout = new QVBoxLayout;
    layout->setContentsMargins(0, 0, 0, 0);
    layout->addWidget(m_titlebar_widget);
    layout->addWidget(m_stackMainWindows);
    layout->setSpacing(0);
    wrapper->setLayout(layout);

    this->setCentralWidget(wrapper);

    m_settingsWidget = new ActivateSettingsWidget(this);

    connect(m_settingsWidget, &ActivateSettingsWidget::importDefaultServerUrl, [ = ](const int &index) {
        quint32 networkStatus = d->getNetworkStatus();
        emit importDefaultServerUrl(index, networkStatus);
    });
    connect(m_settingsWidget, &ActivateSettingsWidget::importCustomServerUrl, [ = ](const int &header,
    const QString & url) {
        quint32 networkStatus = d->getNetworkStatus();
        emit importCustomServerUrl(header, url, networkStatus);
    });

    connect(this, &ActivatorWindow::receiveServerConfUrl,
            m_settingsWidget, &ActivateSettingsWidget::receiveServerConfUrl);

//    if (titlebar()) {
//        titlebar()->setIcon(QIcon::fromTheme("dcc_uosWin"));
//        titlebar()->setFixedHeight(50);
//        titlebar()->setTitle("");

//        // TitleBar Menu
//        DMenu *titleBarMenu = new DMenu(titlebar());
//        titlebar()->setMenu(titleBarMenu);
//        titleBarMenu->addAction(tr("Settings"));
//        titleBarMenu->addAction(tr("Help"));
//        titleBarMenu->addSeparator();
//        titlebar()->setQuitMenuVisible(false);
//        titleBarMenu->addAction(tr("Exit"));

//        connect(titleBarMenu, &DMenu::triggered, this, &ActivatorWindow::onTitleBarMenuClicked);

//        setAccessibleName("mainWindow");
//        titlebar()->setAccessibleName("activatorwindow_titlebar");
//        titleBarMenu->setAccessibleName("titlebar_menu");
//        DWindowOptionButton *optionButton = findChild<DWindowOptionButton *>();
//        if (Q_NULLPTR != optionButton)
//            optionButton->setAccessibleName("optionButton");
//    }

//    this->setTitlebarShadowEnabled(false);
//    CommonMethods::setMainWindow(this);
    d->initUI();
}

ActivatorWindow::~ActivatorWindow()
{
}

void ActivatorWindow::initializationInitialInterface(const LicenseModel &model)
{
    m_operation = NoOperation;
    m_licenseModel = model;
    Q_D(ActivatorWindow);
    Q_EMIT updateView(model);

    if (model.license.state == 1 || model.license.state == 3) {
        m_stackMainWindows->setCurrentWidget(d->successScrollArea);
    } else {
        m_stackMainWindows->setCurrentWidget(d->failedScrollArea);
    }

    d->m_unactivatedWidget->initialize();
    d->m_offlineInlineWidget->initialize();
    d->m_offlineActivatedWidget->initialize();

//    clearFontSizeSignal();
//    d->m_tryFullVersionWidget->setSystemType(model.system.systemType);
//    d->m_importFileWidget->setActivateButtonEnabled(true);
//    d->m_unactivatedWidget->changeFontChangeSignal(true);
//    d->m_unactivatedWidget->systemFontSizeChanged();

//    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
//    d->m_unactivatedWidget->clearButtonFocus();
//    d->m_importFileWidget->initialize();
//    d->m_inputSerialWidget->initialize();
//    d->m_tryFullVersionWidget->initialize();
//    d->m_inputOfflineSerialWidget->initialize();
    update();
}

void ActivatorWindow::showMainWindow() {
    QRect screen = QDesktopWidget().screenGeometry();
    QRect size = this->geometry();
    this->move((screen.width() - size.width()) / 2,
              (screen.height() - size.height()) / 2);
}

void ActivatorWindow::closeEvent(QCloseEvent *event)
{
    Q_UNUSED(event);

//    if (Activated == m_licenseModel.license.state)
//        // exit(0x0000);
//    else
        this->close();
}

void ActivatorWindow::showEvent(QShowEvent *event)
{
    Q_UNUSED(event);
    // titlebar()->clearFocus();
//    QWidget *currentWidget = m_stackMainWindows->currentWidget();
//    currentWidget->setFocus();
}

bool ActivatorWindow::eventFilter(QObject *obj, QEvent *event) {
    if (obj == m_titlebar_widget) {
        static QPoint oldPos;
        if (event->type() == QEvent::MouseButtonPress) {
            QMouseEvent* ev = (QMouseEvent*)event;
            oldPos = ev->globalPos();

            return true;
        }
        else if (event->type() == QEvent::MouseMove) {
            QMouseEvent* ev = (QMouseEvent*)event;
            const QPoint delta = ev->globalPos() - oldPos;
            this->move(this->x() + delta.x(), this->y() + delta.y());

            oldPos = ev->globalPos();
            return true;
        }
    }

    return QWidget::eventFilter(obj, event);
}

void ActivatorWindow::clearFontSizeSignal()
{
    Q_D(ActivatorWindow);

//    d->m_unactivatedWidget->changeFontChangeSignal(false);
//    d->m_activateDetailsWidget->changeFontChangeSignal(false);
//    d->m_tryFullVersionWidget->changeFontChangeSignal(false);
//    d->m_inputSerialWidget->changeFontChangeSignal(false);
//    d->m_importFileWidget->changeFontChangeSignal(false);
//    d->m_inputOfflineSerialWidget->changeFontChangeSignal(false);
}

void ActivatorWindow::onOfflineActivate() {
    Q_D(ActivatorWindow);
    QString license_a = d->m_unactivatedWidget->getProductSerial();
    QString requeset_url = CommonMethods::getOnlineUrlodeUrl() + "?license_a=" + license_a + "&mac=" + d->m_offlineActivatedWidget->getMacAddress().toLower();
    LOG(INFO) << "QRCode" << requeset_url.toStdString();
    d->m_offlineQrcodeWidget->generateQRCode(requeset_url);
    m_stackMainWindows->setCurrentWidget(d->offlineQrcodeScrollArea);
}

void ActivatorWindow::onReturnBtnClicked() {
    Q_D(ActivatorWindow);

    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
}

void ActivatorWindow::onNextBtnClicked() {
    Q_D(ActivatorWindow);

    d->m_offlineActivatedWidget->setProductNum(d->m_unactivatedWidget->getProductSerial());
    m_stackMainWindows->setCurrentWidget(d->offlineActivatedScrollArea);
}

void ActivatorWindow::onPreviousBtnClicked() {
    Q_D(ActivatorWindow);

    m_stackMainWindows->setCurrentWidget(d->offlineQrcodeScrollArea);
}

void ActivatorWindow::onOffActivateBtnClicked(){
    Q_D(ActivatorWindow);
    emit importSerialB(d->m_offlineActivatedWidget->getSerialB());
}

void ActivatorWindow::onFailedReturnBtnClicked() {
    Q_D(ActivatorWindow);

    m_stackMainWindows->setCurrentWidget(d->m_unactivatedWidget);
}

void ActivatorWindow::onOnlineActivate(const QString &online_url, const QString &serial_a) {
    Q_D(ActivatorWindow);

    emit importOnlineSerialA(online_url, serial_a);
}

void ActivatorWindow::onInlineActivate(const QString& url) {
    Q_D(ActivatorWindow);
    std::cout << "onInlineActivate" << std::endl;
    emit importInlineURL(url);
}

void ActivatorWindow::onOfflineActivateWithInline() {
    Q_D(ActivatorWindow);

    m_stackMainWindows->setCurrentWidget(d->offlineInlineScrollArea);
    std::cout << "onOfflineActivateWithInline" << std::endl;
}

void ActivatorWindow::onPreviousBtnClickedInline() {
    Q_D(ActivatorWindow);

    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
    std::cout << "onPreviousBtnClickedInline" << std::endl;
}

void ActivatorWindow::onConfirmBtnClicked() {
    Q_D(ActivatorWindow);

    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
    std::cout << "onConfirmBtnClicked" << std::endl;
}

void ActivatorWindow::onOfflineBtnClickedInline(const QString &serial_b) {
    Q_D(ActivatorWindow);

    std::cout << "onOfflineActivateBtnClickedInline" << std::endl;
    // QString serial_b = "";
    emit importSerialB(serial_b);
}

void ActivatorWindow::onActivateErrorInfo(const QString &message) {
    Q_D(ActivatorWindow);

    m_stackMainWindows->setCurrentWidget(d->failedScrollArea);
}


void ActivatorWindow::onActiveStateChanged(const LicenseModel &model)
{
    m_operation = NoOperation;
    m_licenseModel = model;
    Q_D(ActivatorWindow);
    emit updateView(model);
    // qInfo() << "active status" << model.license.actived;
    clearFontSizeSignal();
    m_stackMainWindows->setCurrentWidget(d->successScrollArea);

//    d->m_tryFullVersionWidget->setSystemType(model.system.systemType);
//    d->m_importFileWidget->setActivateButtonEnabled(true);
//    d->m_unactivatedWidget->changeFontChangeSignal(true);
//    d->m_unactivatedWidget->systemFontSizeChanged(false);

//    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
//    d->m_unactivatedWidget->clearButtonFocus();
//    d->m_importFileWidget->initialize();
//    d->m_inputSerialWidget->initialize();
//    d->m_tryFullVersionWidget->initialize();
//    d->m_inputOfflineSerialWidget->initialize();
    update();
}

void ActivatorWindow::onHeartbeatNotify(const LicenseModel &model)
{
    emit updateView(model);
    update();
}

void ActivatorWindow::onInformationExported(bool success)
{
    emit exportInformation(success);
}

void ActivatorWindow::onTitleBarMenuClicked(QAction *action)
{
    if (tr("Settings") == action->text()) {
        emit requestServerConfUrl();
        m_settingsWidget->systemFontSizeChanged();
        m_settingsWidget->exec();
    } else if (tr("Exit") == action->text()) {
//        if (Activated == m_licenseModel.license.actived)
//            exit(0x0000);
//        else
            this->close();

    } else if (tr("Help") == action->text()) {
       // ManualHelper::openManual();
    }
}

void ActivatorWindow::onOfflineWidgetBackButtonClicked()
{
    Q_D(ActivatorWindow);
    clearFontSizeSignal();
//    if (d->recordWidget == d->m_unactivatedWidget) {
//        d->m_unactivatedWidget->changeFontChangeSignal(true);
//        d->m_unactivatedWidget->systemFontSizeChanged(false);
//        m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
//    } else if (d->recordWidget == d->m_inputSerialWidget) {
//        d->m_inputSerialWidget->changeFontChangeSignal(true);
//        d->m_inputSerialWidget->systemFontSizeChanged(false);
//        m_stackMainWindows->setCurrentWidget(d->inputSerialScrollArea);
//    } else if (d->recordWidget == d->m_importFileWidget) {
//        d->m_importFileWidget->changeFontChangeSignal(true);
//        d->m_importFileWidget->systemFontSizeChanged(false);
//        m_stackMainWindows->setCurrentWidget(d->importFileScrollArea);
//    } else if (d->recordWidget == d->m_tryFullVersionWidget) {
//        d->m_tryFullVersionWidget->changeFontChangeSignal(true);
//        d->m_tryFullVersionWidget->systemFontSizeChanged(false);
//        m_stackMainWindows->setCurrentWidget(d->tryFullVersionScrollArea);
//    } else if (d->recordWidget == d->m_activateDetailsWidget) {
//        d->m_activateDetailsWidget->changeFontChangeSignal(true);
//        d->m_activateDetailsWidget->systemFontSizeChanged(false);
//        m_stackMainWindows->setCurrentWidget(d->activateDetailsScrollArea);
//    } else {}

//    Q_EMIT hideActiveErrorMsg();
//    d->m_inputSerialWidget->initialize();
}

void ActivatorWindow::setWindowHeightAccordingDpi(qint32 dockPosition, qint32 dockHeight,
                                                  qint32 displayHeight, qint32 displayWidth)
{
    // CommonMethods::setMainWindowMaxHeight(dockPosition, dockHeight, displayWidth, displayHeight);
}

void ActivatorWindow::receiveActiveFailMessage(const quint32 &message, const QString &startTime)
{
    Q_D(ActivatorWindow);

    if (!m_abortRequest) {
//        if (m_operation == TrialLicense) {
//            d->m_tryFullVersionWidget->tryLicenseFailTips(message);
//            d->m_tryFullVersionWidget->systemFontSizeChanged(false);
//        } else if (m_operation == SerialLicense || m_operation == ReplaceSerialKey) {
//            d->m_inputSerialWidget->serialLicenseFailTips(message, startTime);
//            d->m_inputSerialWidget->systemFontSizeChanged(false);
//        } else if (m_operation == OfflineLicense) {
//            d->m_inputOfflineSerialWidget->offlineLicenseFailTips(message);
//            d->m_inputOfflineSerialWidget->systemFontSizeChanged(false);
//        } else if (m_operation == FileLicense) {
//            d->m_importFileWidget->fileLicenseFailTips(message, startTime);
//            d->m_importFileWidget->systemFontSizeChanged(false);
//        } else {}
    }

    m_operation = NoOperation;
}

void ActivatorWindow::sendServerMessage(const QString &messageTips)
{
    Q_D(ActivatorWindow);

//    if (!m_abortRequest) {
//        if (m_operation == TrialLicense) {
//            d->m_tryFullVersionWidget->trySendServerMessage(messageTips);
//            d->m_tryFullVersionWidget->systemFontSizeChanged(false);
//        } else if (m_operation == SerialLicense || m_operation == ReplaceSerialKey) {
//            d->m_inputSerialWidget->serialSendServerMessage(messageTips);
//            d->m_inputSerialWidget->systemFontSizeChanged(false);
//        } else if (m_operation == FileLicense) {
//            d->m_importFileWidget->fileSendServerMessage(messageTips);
//            d->m_importFileWidget->systemFontSizeChanged(false);
//        } else {}
//    }

    m_operation = NoOperation;
}

void ActivatorWindow::serverMessageStopWaiting()
{
    Q_D(ActivatorWindow);

//    if (m_operation == TrialLicense)
//        d->m_tryFullVersionWidget->getActivatieWait()->stopWaiting();
//    else if ((m_operation == SerialLicense) || (m_operation == ReplaceSerialKey))
//        d->m_inputSerialWidget->getActivatieWait()->stopWaiting();
//    else if (m_operation == FileLicense)
//        d->m_importFileWidget->getActivatieWait()->stopWaiting();
//    else {}

    m_operation = NoOperation;
}

void ActivatorWindow::onInputSerialClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_inputSerialWidget->changeFontChangeSignal(true);
//    d->m_inputSerialWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->inputSerialScrollArea);
//    d->m_inputSerialWidget->setSerialKeyFocus();
//    d->m_inputSerialWidget->initialize();
//    Q_EMIT hideActiveErrorMsg();
//    d->recordWidget = d->m_inputSerialWidget;
//    d->m_inputSerialWidget->getActivateNowButton()->setEnabled(false);
}

void ActivatorWindow::onReplaceButtonClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_inputSerialWidget->changeFontChangeSignal(true);
//    d->m_inputSerialWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->inputSerialScrollArea);
//    d->m_inputSerialWidget->setSerialKeyFocus();
//    d->m_inputSerialWidget->initialize();
//    d->m_inputSerialWidget->setIsReplaceSerialKey(true);
//    Q_EMIT hideActiveErrorMsg();
//    d->recordWidget = d->m_inputSerialWidget;
//    d->m_inputSerialWidget->getActivateNowButton()->setEnabled(false);
}

void ActivatorWindow::onImportLicenseClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_importFileWidget->changeFontChangeSignal(true);
//    d->m_importFileWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->importFileScrollArea);
//    d->m_importFileWidget->setSerialKeyFocus();
//    d->m_importFileWidget->initialize();
//    Q_EMIT hideActiveErrorMsg();
//    d->recordWidget = d->m_importFileWidget;
}

void ActivatorWindow::onTryFullVersionClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_tryFullVersionWidget->changeFontChangeSignal(true);
//    d->m_tryFullVersionWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->tryFullVersionScrollArea);
//    d->m_tryFullVersionWidget->initialize();
//    Q_EMIT hideActiveErrorMsg();
//    d->recordWidget = d->m_tryFullVersionWidget;
}

void ActivatorWindow::onActivateDetails()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_activateDetailsWidget->changeFontChangeSignal(true);
//    d->m_activateDetailsWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->activateDetailsScrollArea);
//    d->m_unactivatedWidget->clearButtonFocus();
//    d->m_activateDetailsWidget->initialize();
//    d->recordWidget = d->m_activateDetailsWidget;
//    d->m_activateDetailsWidget->updateSerialNumberShow();
}

void ActivatorWindow::onDetailsBackButtonClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_unactivatedWidget->changeFontChangeSignal(true);
//    d->m_unactivatedWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
//    d->m_unactivatedWidget->clearButtonFocus();
//    d->recordWidget = d->m_unactivatedWidget;
}

void ActivatorWindow::onTryFullBackButtonClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_unactivatedWidget->changeFontChangeSignal(true);
//    d->m_unactivatedWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
//    d->m_unactivatedWidget->clearButtonFocus();
//    d->recordWidget = d->m_unactivatedWidget;
    m_abortRequest = true;
}

void ActivatorWindow::onTryFullActivateNowBtnClicked()
{
    Q_D(ActivatorWindow);

    m_abortRequest = false;
    m_operation = TrialLicense;
    quint32 networkStatus = d->getNetworkStatus();

    Q_EMIT tryFullVersion(networkStatus);
}

void ActivatorWindow::onInputSerialBackButtonClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_unactivatedWidget->changeFontChangeSignal(true);
//    d->m_unactivatedWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
//    d->m_unactivatedWidget->clearButtonFocus();
//    d->recordWidget = d->m_unactivatedWidget;
//    m_abortRequest = true;
}

void ActivatorWindow::onInputSerialImportSerialKey(const QString &key)
{
    Q_D(ActivatorWindow);
    m_abortRequest = false;
    m_operation = SerialLicense;
    quint32 networkStatus = d->getNetworkStatus();

    importSerialKey(key, networkStatus);
}

void ActivatorWindow::onInputSerialReplaceSerialKey(const QString &key)
{
    Q_D(ActivatorWindow);

    m_abortRequest = false;
    m_operation = ReplaceSerialKey;
    replaceSerialKey(key, d->getNetworkStatus());
}

void ActivatorWindow::setQrcodeUrl(const QString &urlStr)
{
    Q_D(ActivatorWindow);

//    if (d->m_inputOfflineSerialWidget->getSerialKey().isEmpty())
//        return;

//    if (!m_abortRequest) {
//        clearFontSizeSignal();
//        d->m_inputOfflineSerialWidget->changeFontChangeSignal(true);
//        d->m_inputOfflineSerialWidget->systemFontSizeChanged(false);
//        m_stackMainWindows->setCurrentWidget(d->inputOfflineSerialScrollArea);
//        d->m_inputOfflineSerialWidget->initialize();
//        Q_EMIT hideActiveErrorMsg();
//        d->m_inputOfflineSerialWidget->receiveQRcodeUrl(urlStr);
//    }
}

void ActivatorWindow::onImportFileBackButtonClicked()
{
    Q_D(ActivatorWindow);

    clearFontSizeSignal();
//    d->m_unactivatedWidget->changeFontChangeSignal(true);
//    d->m_unactivatedWidget->systemFontSizeChanged(false);
//    m_stackMainWindows->setCurrentWidget(d->unactivatedScrollArea);
//    d->m_unactivatedWidget->clearButtonFocus();
//    d->recordWidget = d->m_unactivatedWidget;
//    m_abortRequest = true;
}


// ------------------------------ private ------------------------------
void ActivatorWindowPrivate::initUI()
{
    Q_Q(ActivatorWindow);
    network = new Network(q);
    // 未激活窗体
    m_unactivatedWidget = new UnactivatedWidget(q);
    unactivatedScrollArea->setWidget(m_unactivatedWidget);

    // 离线二维码窗体
    m_offlineQrcodeWidget = new OfflineQrcodeWidget(q);
    offlineQrcodeScrollArea->setWidget(m_offlineQrcodeWidget);

    // 离线激活窗体
    m_offlineActivatedWidget = new OfflineActivatedWidget(q);
    offlineActivatedScrollArea->setWidget(m_offlineActivatedWidget);

    // 离线内网激活窗口
    m_offlineInlineWidget = new OfflineInlineWidget(q);
    offlineInlineScrollArea->setWidget(m_offlineInlineWidget);

    //
    m_successWidget = new SuccessWidget(q);
    successScrollArea->setWidget(m_successWidget);

    m_failedWidget =new FailedWidget(q);
    failedScrollArea->setWidget(m_failedWidget);

    // 内网离线窗体

//    //试用期激活窗体
//    m_tryFullVersionWidget = new TryFullVersionWidget(q);
//    tryFullVersionScrollArea->setWidget(m_tryFullVersionWidget);
//    //输入序列号窗体
//    m_inputSerialWidget = new InputSerialWidget(q);
//    inputSerialScrollArea->setWidget(m_inputSerialWidget);
//    //离线激活窗体
//    m_inputOfflineSerialWidget = new InputOfflineSerialWidget(q);
//    inputOfflineSerialScrollArea->setWidget(m_inputOfflineSerialWidget);
//    //导入激活文件窗体
//    m_importFileWidget = new ImportFileWidget(q);
//    importFileScrollArea->setWidget(m_importFileWidget);
//    //查看详情
//    m_activateDetailsWidget = new ActivateDetails(q);
//    activateDetailsScrollArea->setWidget(m_activateDetailsWidget);

//    q->m_stackMainWindows->addWidget(unactivatedScrollArea);
//    q->m_stackMainWindows->addWidget(inputSerialScrollArea);
//    q->m_stackMainWindows->addWidget(importFileScrollArea);
//    q->m_stackMainWindows->addWidget(inputOfflineSerialScrollArea);
//    q->m_stackMainWindows->addWidget(tryFullVersionScrollArea);
//    q->m_stackMainWindows->addWidget(activateDetailsScrollArea);

//    q->clearFontSizeSignal();
//    m_unactivatedWidget->changeFontChangeSignal(true);
//    m_unactivatedWidget->systemFontSizeChanged();
//    q->setFixedWidth(520);

    q->m_stackMainWindows->addWidget(unactivatedScrollArea);
    q->m_stackMainWindows->addWidget(offlineQrcodeScrollArea);
    q->m_stackMainWindows->addWidget(offlineActivatedScrollArea);
    q->m_stackMainWindows->addWidget(offlineInlineScrollArea);

    q->m_stackMainWindows->addWidget(successScrollArea);
    q->m_stackMainWindows->addWidget(failedScrollArea);


    q->setFixedWidth(780);
    q->m_stackMainWindows->setCurrentWidget(unactivatedScrollArea);
    initConnection();
}

void ActivatorWindowPrivate::initConnection()
{
    Q_Q(ActivatorWindow);

    // 主界面
    // 外网在线
    q->connect(m_unactivatedWidget, SIGNAL(importSerialKey(const QString&, const QString&)), q, SLOT(onOnlineActivate(const QString&, const QString&)));
    q->connect(m_unactivatedWidget, SIGNAL(offlineActivateWithOnline()), q, SLOT(onOfflineActivate()));

    // 外网离线
    q->connect(m_offlineQrcodeWidget, SIGNAL(returnBtnClicked()), q, SLOT(onReturnBtnClicked()));
    q->connect(m_offlineQrcodeWidget, SIGNAL(nextBtnClicked()), q, SLOT(onNextBtnClicked()));

    q->connect(m_offlineActivatedWidget, SIGNAL(previousBtnClicked()), q, SLOT(onPreviousBtnClicked()));
    q->connect(m_offlineActivatedWidget, SIGNAL(offActivateBtnClicked()), q, SLOT(onOffActivateBtnClicked()));


    // 内网在线
    q->connect(m_unactivatedWidget, SIGNAL(activateWithInline(const QString&)), q, SLOT(onInlineActivate(const QString&)));
    q->connect(m_unactivatedWidget, SIGNAL(offlineActivateWithInline()), q, SLOT(onOfflineActivateWithInline()));
    // 内网离线
    q->connect(m_offlineInlineWidget, SIGNAL(previousBtnClickedInline()), q, SLOT(onPreviousBtnClickedInline()));
    q->connect(m_offlineInlineWidget, SIGNAL(offActivateBtnClickedInline(const QString&)), q, SLOT(onOfflineBtnClickedInline(const QString&)));
    q->connect(m_offlineInlineWidget, SIGNAL(offActivateBtnClickedInline()), q, SLOT(onPreviousBtnClickedInline()));


    // failed widget
    q->connect(m_failedWidget, SIGNAL(failedReturnBtnClicked()), q, SLOT(onPreviousBtnClickedInline()));
    q->connect(m_successWidget, SIGNAL(confirmBtnClicked()), q, SLOT(onConfirmBtnClicked()));

    //
    q->connect(q, &ActivatorWindow::updateView, m_successWidget, &SuccessWidget::updateView);
    q->connect(q, &ActivatorWindow::updateView, m_failedWidget, &FailedWidget::updateView);
    q->connect(q, &ActivatorWindow::updateView, m_unactivatedWidget, &UnactivatedWidget::updateView);


//    //主界面
//    q->connect(q, &ActivatorWindow::updateView, m_unactivatedWidget, &UnactivatedWidget::updateView);
//    q->connect(m_unactivatedWidget, &UnactivatedWidget::inputSerialClicked, q,
//               &ActivatorWindow::onInputSerialClicked);
//    q->connect(m_activateDetailsWidget, &ActivateDetails::replaceButtonClicked, q,
//               &ActivatorWindow::onReplaceButtonClicked);
//    q->connect(m_unactivatedWidget, &UnactivatedWidget::importLicenseClicked, q,
//               &ActivatorWindow::onImportLicenseClicked);
//    q->connect(m_unactivatedWidget, &UnactivatedWidget::tryFullVersionClicked, q,
//               &ActivatorWindow::onTryFullVersionClicked);

//    //查看详情
//    q->connect(m_unactivatedWidget, &UnactivatedWidget::activateDetails, q, &ActivatorWindow::onActivateDetails);
//    q->connect(q, &ActivatorWindow::updateView, m_activateDetailsWidget, &ActivateDetails::updateView);

//    q->connect(m_activateDetailsWidget, &ActivateDetails::backButtonClicked, q,
//               &ActivatorWindow::onDetailsBackButtonClicked);

//    //试用期激活
//    q->connect(m_tryFullVersionWidget, &TryFullVersionWidget::backButtonClicked, q,
//               &ActivatorWindow::onTryFullBackButtonClicked);
//    q->connect(m_tryFullVersionWidget, &TryFullVersionWidget::activateNowBtnClicked, q,
//               &ActivatorWindow::onTryFullActivateNowBtnClicked);
//    q->connect(q, &ActivatorWindow::hideActiveErrorMsg,
//               m_tryFullVersionWidget, &TryFullVersionWidget::hideTryFailMsg);

//    //序列号激活
//    q->connect(m_inputSerialWidget, &InputSerialWidget::backButtonClicked, q,
//               &ActivatorWindow::onInputSerialBackButtonClicked);
//    q->connect(m_inputSerialWidget, &InputSerialWidget::importSerialKey, q,
//               &ActivatorWindow::onInputSerialImportSerialKey);
//    q->connect(m_inputSerialWidget, &InputSerialWidget::replaceSerialKey, q,
//               &ActivatorWindow::onInputSerialReplaceSerialKey);

//    q->connect(m_inputSerialWidget, &InputSerialWidget::setSerialKey, q, [ = ](const QString & key) {
//        qInfo() << "SerialKeyToOfflineSerialWidget:   " << LogEncryption::encryptionMessage(key);
//        q->setSerialKey(key);
//    });
//    q->connect(q, &ActivatorWindow::hideActiveErrorMsg, m_inputSerialWidget,
//               &InputSerialWidget::hideActiveErrorMsg);

//    //离线激活
//    q->connect(q, &ActivatorWindow::updateView, m_inputOfflineSerialWidget,
//               &InputOfflineSerialWidget::updateView);
//    q->connect(q, &ActivatorWindow::setSerialKey, m_inputOfflineSerialWidget,
//               &InputOfflineSerialWidget::receiveSerialKey);
//    q->connect(m_inputOfflineSerialWidget, &InputOfflineSerialWidget::backButtonClicked, q, [ = ]() {
//        q->onOfflineWidgetBackButtonClicked();
//    });
//    q->connect(m_inputOfflineSerialWidget, &InputOfflineSerialWidget::importOfflineSerialKey,
//    q, [ = ](const QString & key, const QString &activationKey) {
//        q->m_operation = OfflineLicense;
//        q->importOfflineSerialKey(key, activationKey);
//    });
//    q->connect(q, &ActivatorWindow::hideActiveErrorMsg, m_inputOfflineSerialWidget,
//               &InputOfflineSerialWidget::hideActiveErrorMessage);

//    //文件激活
//    q->connect(m_importFileWidget, &ImportFileWidget::backButtonClicked, q,
//               &ActivatorWindow::onImportFileBackButtonClicked);
//    q->connect(m_importFileWidget, &ImportFileWidget::importSerialKey, q, [ = ](const QString & key,
//    const qint32 & isActiveFile) {
//        q->m_abortRequest = false;
//        q->m_operation = FileLicense;
//        quint32 networkStatus = getNetworkStatus();

//        q->importSerialKey(key, networkStatus, isActiveFile);
//    });
//    q->connect(m_importFileWidget, &ImportFileWidget::setSerialKey, q, [ = ](const QString & key) {
//        qInfo() << "fileSerialKeyToOfflineSerialWidget:   " << LogEncryption::encryptionMessage(key);
//        q->setSerialKey(key);
//    });
//    q->connect(m_importFileWidget, &ImportFileWidget::importVolumeSerialKey,
//    q, [ = ](QString licensePath) {
//        q->m_abortRequest = false;
//        q->m_operation = FileLicense;
//        quint32 networkStatus = getNetworkStatus();

//        q->importVolumeSerialKey(licensePath, networkStatus);
//    });
//    q->connect(q, &ActivatorWindow::hideActiveErrorMsg, m_importFileWidget,
//               &ImportFileWidget::hideActiveErrorMessage);
}

quint32 ActivatorWindowPrivate::getNetworkStatus()
{
    quint32 networkStatus = InitNetworkState;

    if (network->checkLocalNetwork())
        networkStatus = NetOnLine;
    else
        networkStatus = NetOffLine;

    return networkStatus;
}
