#include "licensetrayicon.h"
#include "licensemodel.h"

#include <QIcon>
#include <QSystemTrayIcon>
#include <QMenu>
#include <QAction>

LicenseTrayIcon::LicenseTrayIcon(QObject *parent) : QObject(parent)
{
    initUi();
    initConnection();
}

LicenseTrayIcon::~LicenseTrayIcon()
{
    if (m_titleBarMenu) {
        m_titleBarMenu->deleteLater();
        m_titleBarMenu = Q_NULLPTR;
    }
}

void LicenseTrayIcon::initUi()
{
    m_systemTray = new QSystemTrayIcon(this);
    // m_systemTray->setToolTip(tr("Authorization"));
    m_systemTray->setToolTip(tr("授权认证工具"));
    m_titleBarMenu = new QMenu();
    // m_quitAction = new QAction(tr("Exit"), m_titleBarMenu);
    m_quitAction = new QAction(tr("退出"), m_titleBarMenu);
//    m_titleBarMenu->addAction(m_quitAction);
//    m_systemTray->setContextMenu(m_titleBarMenu);
}


void LicenseTrayIcon::initConnection()
{
    connect(m_systemTray, SIGNAL(activated(QSystemTrayIcon::ActivationReason)),
            this, SLOT(onActivated(QSystemTrayIcon::ActivationReason)));
    connect(m_quitAction, &QAction::triggered, this, &LicenseTrayIcon::endGui);
    // connect(m_systemTray, &QSystemTrayIcon::activated, this, &LicenseTrayIcon::clickTrayIconShowWindow);
}

void LicenseTrayIcon::onTrayIconFlush(quint32 authorizationState, bool isActiveStateChanged)
{
    if (authorizationState == Authorized) {
        m_systemTray->setIcon(m_systrayTrueIcon);
        if (!isActiveStateChanged)
            m_systemTray->hide();
    } else if (authorizationState == TrialAuthorized) {
        m_systemTray->setIcon(m_systrayTrialAuthorizedIcon);
        m_systemTray->show();
    } else {
        m_systemTray->setIcon(m_systrayFalseIcon);
        m_systemTray->show();
    }
}

void LicenseTrayIcon::onIconFlash(quint32 authorizationState)
{
    if (m_currentAuthState != authorizationState) {
        onTrayIconFlush(authorizationState, true);
        m_currentAuthState = authorizationState;
    }
}

void LicenseTrayIcon::onShowTrayIcon()
{
    m_systemTray->show();
}

void LicenseTrayIcon::onActivated(QSystemTrayIcon::ActivationReason reason) {
    switch(reason) {
    case QSystemTrayIcon::Trigger: // single click
    case QSystemTrayIcon::MiddleClick:
    case QSystemTrayIcon::DoubleClick:
        emit clickTrayIconShowWindow();
        break;
    default:
        return;
    }
}
