#ifndef LICENSETRAYICON_H
#define LICENSETRAYICON_H

// #include <DMenu>
#include <QSystemTrayIcon>
#include <QObject>
#include <QIcon>

// DWIDGET_USE_NAMESPACE

class QSystemTrayIcon;
class QAction;
class QMenu;
class LicenseTrayIcon : public QObject
{
    Q_OBJECT
public:
    explicit LicenseTrayIcon(QObject *parent);
    ~LicenseTrayIcon();

public slots:
    void onTrayIconFlush(quint32 authorizationState, bool isActiveStateChanged = false);
    void onIconFlash(quint32 authorizationState);
    void onShowTrayIcon();
    void onActivated(QSystemTrayIcon::ActivationReason);

signals:
    void clickTrayIconShowWindow();
    void endGui();

private:
    void initUi();
    void initConnection();

    QSystemTrayIcon *m_systemTray = Q_NULLPTR;
    QMenu *m_titleBarMenu = Q_NULLPTR;
    QAction * m_quitAction = Q_NULLPTR;
    quint32 m_currentAuthState = 0;
    QIcon m_systrayTrueIcon = QIcon::fromTheme(":/icons/deepin/builtin/icons/dcc_uosSystrayTrue_20px.svg");
    QIcon m_systrayTrialAuthorizedIcon = QIcon::fromTheme
            (":/icons/deepin/builtin/icons/dcc_uosSystrayTrialAuthorized_20px.svg");
    QIcon m_systrayFalseIcon = QIcon::fromTheme(":/icons/deepin/builtin/icons/dcc_uosSystrayFalse_20px.png");
};

#endif // LICENSETRAYICON_H
