#ifndef ACTIVATESETTINGSWIDGET_H
#define ACTIVATESETTINGSWIDGET_H

// #include <DMainWindow>
// #include <DLineEdit>
// #include <DDialog>
// #include <DSuggestButton>
// #include <DComboBox>
// #include <DPushButton>
// #include <DRadioButton>
// #include <DLabel>

#include <QMainWindow>
#include <QLineEdit>
#include <QDialog>
// #include <QSuggestButton>
#include <QComboBox>
#include <QPushButton>
#include <QRadioButton>
#include <QLabel>

#include <QWidget>
#include <QDBusInterface>

// DWIDGET_USE_NAMESPACE

class ActivateSettingsWidget : public QDialog
{
    Q_OBJECT
public:
    explicit ActivateSettingsWidget(QWidget *parent = Q_NULLPTR);

public slots:
    void receiveServerConfUrl(const QVariantMap &serverCon);
    void systemFontSizeChanged(const QString & = "", const QString & = "");
    void onCustomURLTextChanged(const QString &url);
    void onCustomURLIndexChanged(int index);

signals:
    //设置自定义激活服务器地址
    void importCustomServerUrl(const int &header, const QString &url);
    //设置默认激活服务器地址
    void importDefaultServerUrl(const int &index);

private:
    void initUI();
    void initConnection();
    void setUIEnable(bool enable);
    void defaultRadioBtnClicked(bool checked);
    void customRadioBtnClicked(bool checked);
    void confirmButtonClicked();
    void serverUrlNotify(bool isDefault, const QString &url);
    void checkCustomUrlAndKMSUrl(const QString &url);
    void initTemporaryData(const QVariantList &urlList);
    void switchSavedServerUrl(const QString &header);
    void autoTestSettingCode();

private:
    QLabel *m_enableServerLabel;
    QRadioButton *m_defaultRadioButton;
    QRadioButton *m_customRadioButton;
    QComboBox *m_defaultURLComboBox;
    QComboBox *m_customURLPreComboBox;
    QLineEdit *m_customURLLineEdit;
    QPushButton *m_cancelButton;
    // DSuggestButton *m_confirmButton;
    QDBusInterface *m_settingsWidgetFontChange;
    QString m_defaultRadioButtonText;
    QString m_customRadioButtonText;
    QMap<QString, QString> m_temporaryData;
    QString previousProtocol;
    bool m_isInitUI = true;
};

#endif // ACTIVATESETTINGSWIDGET_H
