#include "active_file_widget.h"
#include "ui_active_file_widget.h"
#include <QFileDialog>
#include <QSettings>
#include <QTextCodec>
#include "status_widget.h"
#include "../easylogging++.h"

active_file_widget::active_file_widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::active_file_widget)
{
    ui->setupUi(this);
    ui->label_3->setVisible(false);
}

active_file_widget::~active_file_widget()
{
    delete ui;
}

void active_file_widget::on_pushButton_clicked()
{
    ui->label_3->setVisible(false);
    strpath = QFileDialog::getOpenFileName();
    LOG(INFO) << ".key_path:" << strpath;

    if(strpath.isEmpty() || strpath.isNull() || !strpath.contains(".key"))
    {
        return;
    }

    if(strpath.length() > 40)
    {
        ui->lineEdit->setText(strpath.left(10) + "........." + strpath.right(10));
    }
    else
    {
        ui->lineEdit->setText(strpath);
    }
}

void active_file_widget::on_pushButton_2_clicked()
{
    QString filepath = ui->lineEdit->text();
    if(filepath == "")
    {
        return;
    }

    if(!filepath.contains("......"))
    {
        strpath = filepath;
    }

    QSettings confIniRead(strpath, QSettings::IniFormat);
    confIniRead.setIniCodec(QTextCodec::codecForName("UTF-8"));
    QString product_name = confIniRead.value("LICENSE/Name").toString();
    QString licence_b = confIniRead.value("LICENSE/Licence_b").toString();
    QString label = confIniRead.value("LICENSE/Label").toString();

    if(label != status_widget::GetInstance()->get_label())
    {
        ui->label_3->setVisible(true);
        return;
    }

    bIsclick = true;
    status_widget::GetInstance()->Is_file_active_click = false;
    emit importSerialB(licence_b, product_name);
    status_widget::GetInstance()->load_ptr->show();

    ui->pushButton_2->setStyleSheet("QPushButton{background: #A6D1FF; color: #FFFFFF; font-size: 14px; border-radius: 6px; border: none;}");
    ui->pushButton_3->setStyleSheet("QPushButton{color: #B8B8B8; border: 1px solid #E4E4E4; font-size: 14px; border-radius: 6px;}");
    ui->pushButton_2->setEnabled(false);
    ui->pushButton_3->setEnabled(false);

    ui->lineEdit->clear();
    strpath = "";
}

void active_file_widget::on_pushButton_3_clicked()
{
    status_widget::GetInstance()->Is_file_active_click = false;
    status_widget::GetInstance()->take_active_file_widget();
    status_widget::GetInstance()->set_status_widget();
    ui->lineEdit->clear();
    ui->label_3->setVisible(false);
}

void active_file_widget::recover_style_sheet()
{
    ui->pushButton_2->setStyleSheet("QPushButton{background: #007AFF; color: #FFFFFF; font-size: 14px; border-radius: 6px; border: none;}");
    ui->pushButton_3->setStyleSheet("QPushButton{color: #333333; border: 1px solid #B3B3B3; font-size: 14px; border-radius: 6px;}");
    ui->pushButton_2->setEnabled(true);
    ui->pushButton_3->setEnabled(true);
}
