#include "active_status.h"
#include "ui_active_status.h"
#include "status_widget.h"

active_status::active_status(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::active_status)
{
    ui->setupUi(this);
    ui->label_2->setWordWrap(true);

    m_startValue = 3;
    m_pTimer = new QTimer(this);
    connect(m_pTimer, SIGNAL(timeout()), this, SLOT(on_timer_timeout()));
    m_pTimer->setInterval(1000);
}

active_status::~active_status()
{
    if(m_pTimer != nullptr)
    {
        delete m_pTimer;
        m_pTimer = nullptr;
    }

    delete ui;
}

void active_status::init(bool bret, const QString msg)
{
    m_startValue = 3;
    ui->label_3->setText("将在3秒后自动返回首页");

    if(bret)
    {
        QPixmap px(":/icons/deepin/builtin/icons/icon_success.png");
        ui->label->setPixmap(px);
        ui->label->setScaledContents(true);
        //ui->label->setStyleSheet("QLabel{image: url(:/icons/deepin/builtin/icons/icon_success.png);}");
        ui->label_2->setText("激活成功");
    }
    else
    {
        QPixmap px(":/icons/deepin/builtin/icons/icon_fail.png");
        ui->label->setPixmap(px);
        ui->label->setScaledContents(true);
        //ui->label->setStyleSheet("QLabel{image: url(://icons/deepin/builtin/icons/icon_fail.png);}");
        ui->label_2->setText(msg);
    }
}

void active_status::on_pushButton_clicked()
{
    status_widget::GetInstance()->Is_import_start_productD = false;
    m_pTimer->stop();
    status_widget::GetInstance()->take_active_status();
    status_widget::GetInstance()->set_status_widget();
}

void active_status::on_timer_timeout()
{
    if(m_startValue == 0)
    {
        status_widget::GetInstance()->Is_import_start_productD = false;
        m_pTimer->stop();
        on_pushButton_clicked();
        return;
    }

    ui->label_3->setText("将在" + QString::number(m_startValue) + "秒后自动返回首页");
    m_startValue--;
}

void active_status::run()
{
    m_pTimer->start();
}
