#ifndef ACTIVE_WIDGET_H
#define ACTIVE_WIDGET_H

#include <QWidget>
#include <QValidator>

namespace Ui {
class active_widget;
}

class active_widget : public QWidget
{
    Q_OBJECT

public:
    explicit active_widget(QWidget *parent = 0);
    ~active_widget();

    void set_lineedit_able();
    void set_lineedit_unable();
    void clear_lineedit();

    bool bIsclick = false;

    void recover_style_sheet();

private slots:
    void on_pushButton_back_clicked();
    void on_pushButton_active_clicked();

    void on_lineEdit_seq_a_textChanged(const QString &arg1);

    void on_lineEdit_seq_b_textChanged(const QString &arg1);

private:
    Ui::active_widget *ui;
    QValidator* validator_a = nullptr;
    QValidator* validator_b = nullptr;
    QValidator* validator_c = nullptr;
    QString default_url = "";
    QString serial_a = "";

signals:
    void importOnlineSerialA(const QString &online_url, const QString& serial_a, const QString& label);
    void request_network_state(const QString &url);

public slots:
    void recv_Network_State(bool bState);
};

#endif // ACTIVE_WIDGET_H
