#ifndef OFFLINE_ACTIVATED_WIDGET_H
#define OFFLINE_ACTIVATED_WIDGET_H

#include <QWidget>
#include "ui_offline-activated-widget.h"

class OfflineActivatedWidget : public QWidget,
                    public Ui::OfflineActivatedWidget
{
    Q_OBJECT
public:
    OfflineActivatedWidget(QWidget *parent=0);
    ~OfflineActivatedWidget();

    void initUI();
    void initConnection();
    void initialize();

    void setProductNum(const QString& product_num);
    QString getMacAddress(bool deleteColon = false);
    QString getSerialB();

public slots:
    void onPreviousBtnClicked();
    void onOffActivateBtnClicked();

signals:
    void previousBtnClicked();
    void offActivateBtnClicked();

private:
    QStringList m_physicsMacDevices;
    QStringList m_virtualMacDevices;
    Q_DISABLE_COPY(OfflineActivatedWidget)
};

#endif // OFFLINE_ACTIVATED_WIDGET_H
