#ifndef OFFLINE_ACTIVE_WIDGET_H
#define OFFLINE_ACTIVE_WIDGET_H

#include <QWidget>
#include <QValidator>

namespace Ui {
class offline_active_widget;
}

class offline_active_widget : public QWidget
{
    Q_OBJECT

public:
    explicit offline_active_widget(QWidget *parent = 0);
    ~offline_active_widget();

    void init_offline_widget(const QString &url, const QString &disk);

    bool bIsclick = false;

    void recover_style_sheet();

private slots:
    void on_pushButton_back_clicked();

    void on_pushButton_offline_active_clicked();

    void on_lineEdit_offline_active_seq_textChanged(const QString &arg1);

    void on_lineEdit_offline_active_seq_2_textChanged(const QString &arg1);

    void on_lineEdit_offline_active_seq_3_textChanged(const QString &arg1);

    void on_lineEdit_offline_active_seq_4_textChanged(const QString &arg1);

private:
    Ui::offline_active_widget *ui;
    QString serial_a = "";
    QValidator* validator_a = nullptr;
    QValidator* validator_b = nullptr;
    QValidator* validator_c = nullptr;
    QValidator* validator_d = nullptr;
    QValidator* validator_e = nullptr;

    void generateQRCode(const QString& url);
    void clear_lineedit();

signals:
    void offline_importSerialB(const QString& serial_b, const QString& product_name, const QString& serial_a);
    //void initMainWindow();
};

#endif // OFFLINE_ACTIVE_WIDGET_H
