#ifndef SETTING_WIDGET_H
#define SETTING_WIDGET_H

#include <QWidget>
#include <QMouseEvent>

namespace Ui {
class setting_widget;
}

class setting_widget : public QWidget
{
    Q_OBJECT

public:
    explicit setting_widget(QWidget *parent = 0);
    ~setting_widget();

    void init(const QString &defaultUrl, const bool bRet, const QString &confCustomUrl);
    void set_style_sheet();
    void recover_style_sheet();
    void check_net_work(bool flag);

    bool Is_connect = false;
    bool Is_modify_kms = false;

private slots:
    void on_pushButton_cancel_clicked();

    void on_pushButton_ok_clicked();

    void on_pushButton_2_clicked();

    void on_lineEdit_agent_addr_textChanged(const QString &arg1);

    void on_radioButton_default_clicked();

private:
    Ui::setting_widget *ui;
    QPoint m_offset;
    QString confCustomURL = "";
    bool confDefault = false;
    QString defaultURL = "";

signals:
    void importCustomServerUrl(const QString &url);
    void importDefaultServerUrl();
    void request_kms_network_state(const QString &url);
};

#endif // SETTING_WIDGET_H
