#ifndef STATUS_WIDGET_H
#define STATUS_WIDGET_H

#include <QWidget>
#include <QMouseEvent>
#include "setting_widget.h"
#include "active_widget.h"
#include "offline_active_widget.h"
#include "../common/interface/licensemodel.h"
#include "active_status.h"
#include <QMenu>
#include <QAction>
#include "information_widget.h"
#include "active_file_widget.h"
#include "formloading.h"
#include "react_active_widget.h"

namespace Ui {
class status_widget;
}

class status_widget : public QWidget
{
    Q_OBJECT

public:
    static status_widget* GetInstance();
    void release();
    void take_active_widget();
    void set_status_widget();
    void click_input_seq();
    void take_offline_active_widget();
    void show_offline_active_widget();
    void take_react_active_widget();
    void show_react_active_widget();
    void show_react_active();
    void hide_react_active();
    void init(const LicenseModel &model, bool showProbationPeriod);
    QString get_product_name();
    QString get_customurl();
    QString get_default_url();
    QString get_label();
    void change_button(const QString str);
    void show_error_widget(const QString msg);
    void take_active_status();
    void take_active_file_widget();
    void set_version(const QString &ver);

    setting_widget *set_widget_ptr = nullptr;
    active_widget *act_widget_ptr = nullptr;
    offline_active_widget* offline_active_widget_ptr = nullptr;
    active_status* active_status_ptr = nullptr;
    Information_widget* Info_widget_ptr = nullptr;
    active_file_widget* active_file_widget_ptr = nullptr;
    FormLoading* load_ptr = nullptr;
    react_active_widget* react_active_widget_ptr = nullptr;
    bool bIsclick = false;
    bool Is_import_start_productD = false;
    bool Is_file_active_click = false;
    bool Is_input_click = false;
    QString mac = "";
    QString disk = "";
    QString sn = "";

private slots:
    void on_pushButton_close_clicked();

    void on_pushButton_input_seq_clicked();

    void on_pushButton_input_file_clicked();

    void on_pushButton_clicked();

    void show_setting_widget();

    void show_information_widget();

    void show_reactivation_widget();

private:
    Ui::status_widget *ui;
    QWidget* widget = nullptr;
    static status_widget *instane;
    QPoint mouseStartPoint;
    QPoint windowTopLeftPoint;
    bool m_bDrag = false;
    bool bRet = false;
    bool Is_react_click = false;
    QString defaulturl = "";
    QString customurl = "";
    QString confCustomUrl = "";
    QString qrcodepath = "";
    QString label = "";
    QMenu* pMenu = nullptr;
    QAction* pAction_set = nullptr;
    QAction* pAction_info = nullptr;
    QAction* pAction_react = nullptr;

    explicit status_widget(QWidget *parent = 0);
     ~status_widget();

    void read_file();
    void create_menu();
    void create_load();
    void recover_style_sheet();
    void recover_style();

protected:
    virtual void mouseMoveEvent(QMouseEvent* event);
    virtual void mousePressEvent(QMouseEvent* event);
    virtual void mouseReleaseEvent(QMouseEvent* event);

signals:
    void importInlineURL(const QString &url, const QString &type);
    void importOnlineSerialA(const QString &online_url, const QString& serial_a, const QString& label);
    void importSerialB(const QString& serial_b, const QString& product_name);
    void offline_importSerialB(const QString& serial_b, const QString& product_name, const QString& serial_a);
    void importCustomServerUrl(const QString &url);
    void requestServerConfUrl();
    void importDefaultServerUrl();
    void importStartProductD(const QString &url, const QString &label);
    //void initMainWindow();
    void request_network_state(const QString &url);
    void sendNetworkState(bool bState);
    void sendKmsNetworkState(bool flag);

public slots:
    void receiveServerConfUrl(const QVariantMap &serverConfUrl);
    void show_success_widget(const LicenseModel &licenseModel);
    void get_network_state(bool bState);
};

#endif // STATUS_WIDGET_H
