#include <QtWidgets>
#include <QPixmap>
#include <QImage>
#include <iostream>

#include "success-widget.h"
#include "licensemodel.h"
#include "easylogging++.h"

namespace {

} // namespace

SuccessWidget::SuccessWidget(QWidget *parent)
    : QWidget(parent)
{
    setupUi(this);
    initConnection();
}

SuccessWidget::~SuccessWidget() {

}

void SuccessWidget::initConnection() {
    connect(mConfirmBtn, SIGNAL(clicked()),
            this, SLOT(onConfirmBtnClicked()));
}

void SuccessWidget::onConfirmBtnClicked() {
    LOG(INFO) << "SuccessWidget onConfirmBtnClicked";
    //if (m_licenseModel.license.state != 1) {
        emit confirmBtnClicked();
    //} else {
        // exit(0x0000);
    //}
}

void SuccessWidget::updateView(const LicenseModel &model) {
    m_licenseModel = model;

    mProductName->setText(model.license.product_name);
    if (model.license.state == 0) {
        mState->setText("未授权");
    } else if (model.license.state == 1) {
        mState->setText("已授权");
    } else if (model.license.state == 2) {
        mState->setText("已过期");
    } else if (model.license.state == 3) {
        mState->setText("试用期授权");
    } else if (model.license.state == 4) {
        mState->setText("试用期过期");
    } else {
        mState->setText("未知");
    }
    mMacLab->setText(model.license.mac);
    mSerialB->setText(model.license.serial_b);
    mValidDate->setText(model.license.valid_date);
}
