#include "unactivatedwidget.h"
#include "uihelper.h"

//#include <DFontSizeManager>
//#include <DHiDPIHelper>
//#include <DMessageManager>
//#include <DSuggestButton>
//#include <DPushButton>
//#include <DDialog>
//#include <DFrame>
//#include <DSysInfo>

//#include <DFontSizeManager>
//#include <DHiDPIHelper>
//#include <DMessageManager>
//#include <DSuggestButton>
#include <QPushButton>
#include <QDialog>
#include <QFrame>
//#include <DSysInfo>

#include <QString>
#include <QVBoxLayout>
#include <QGridLayout>
#include <QPushButton>
#include <QDebug>
#include <QDBusInterface>
#include <QSpacerItem>
#include <QSettings>
#include <QImage>
#include <QPixmap>
#include <QListView>

#include "easylogging++.h"

//DWIDGET_USE_NAMESPACE
//DCORE_USE_NAMESPACE

namespace {
constexpr qint32 minimumHeightOfInterface = 670;
constexpr qint32 edgeRemainWidth = 40;
constexpr qint32 maxWidgetWidth = 780;
}

UnactivatedWidget::UnactivatedWidget(QWidget *parent)
    : QWidget(parent)
{
    initUI();
    initConnection();
}

UnactivatedWidget::~UnactivatedWidget() {

}

QString UnactivatedWidget::getProductSerial(){
    m_ProductSerial = mProductNumLe->text();
    return m_ProductSerial;
}

void UnactivatedWidget::initUI()
{
    setupUi(this);
    QString str = "QComboBox QAbstractItemView:item\
    \n{\
        font-size:12px;\n\
        min-height:30px;\n\
        min-width:20px;\n\
    }\n";

    //QListView* listView = new QListView();
    //mActivateChoice->setView(listView);
    //mActivateChoice->setStyleSheet(str);

    //mActivateChoice->insertItem(UnactivatedWidget::OnlineActivation, "联网激活");
    //mActivateChoice->insertItem(UnactivatedWidget::inlineActivation, "代理激活");
    // mActivateChoice->insertItem(UnactivatedWidget::UKeyActivation, "Ukey激活");
    mActivateChoice->addItem("联网激活");
    mActivateChoice->addItem("代理激活");

    mActivateChoice->setStyleSheet(tr("QComboBox::drop-down{image: url(:/icons/deepin/builtin/icons/comobox_expand.png); border: none}"
                                      "QComboBox::drop-down:pressed{image: url(:/icons/deepin/builtin/icons/comobox_stowed.png);}"
                                      "QComboBox QAbstractItemView:item{font-size:12px; min-height:30px; min-width:20px;}"
                                      "QComboBox{combobox-popup: 0;}"
                                      "QComboBox QAbstractItemView{border: 1px solid gray ;border-radius: 4px;}"
                                      "QComboBox:on{image: url(:/icons/deepin/builtin/icons/comobox_stowed.png);};"));

    mActivateChoice->setView(new QListView());

    mActivateChoice->setCurrentIndex(UnactivatedWidget::OnlineActivation);
    this->changeAcitvateWay(UnactivatedWidget::OnlineActivation);
    mActivateChoice->setEditable(false);

    mProductContent->setText(CommonMethods::getProductName());

    this->setFixedWidth(maxWidgetWidth);
}

void UnactivatedWidget::initConnection()
{
    connect(mActivateChoice, SIGNAL(currentIndexChanged(int)),
            this, SLOT(changeAcitvateWay(int)));

    connect(mActivatedBtn, SIGNAL(clicked()),
            this, SLOT(onActivatedBtnClicked()));

    connect(mOfflineBtn, SIGNAL(clicked()),
            this, SLOT(onOfflineBtnClicked()));
}

void UnactivatedWidget::changeAcitvateWay(int type) {
    mProductSerial->setVisible(ActivateType::OnlineActivation == type);
    mProductNumLe->setVisible(ActivateType::OnlineActivation == type);

    mServeAddress->setVisible(ActivateType::inlineActivation == type);
    mServerLe->setVisible(ActivateType::inlineActivation == type);
}

void UnactivatedWidget::onActivatedBtnClicked() {
    int current_index = mActivateChoice->currentIndex();
    if (ActivateType::OnlineActivation == current_index) {
        emit importSerialKey(CommonMethods::getOnlineUrl(), mProductNumLe->text());
    } else if (ActivateType::inlineActivation == current_index) {

        emit activateWithInline(mServerLe->text());
    } else if (ActivateType::UKeyActivation == current_index) {

    }
}

void UnactivatedWidget::onOfflineBtnClicked() {
    int current_index = mActivateChoice->currentIndex();
    if (ActivateType::OnlineActivation == current_index) {
        emit offlineActivateWithOnline();
    } else if (ActivateType::inlineActivation == current_index) {
        emit offlineActivateWithInline();
    } else if (ActivateType::UKeyActivation == current_index) {

    }
}

void UnactivatedWidget::updateView(const LicenseModel &model) {
    mProductContent->setText(model.license.product_name);
}

void UnactivatedWidget::initialize() {
    mProductNumLe->setText("");
    mServerLe->setText("");
}
