#ifndef UNACTIVATEDWIDGET_H
#define UNACTIVATEDWIDGET_H
#include "ui_unactivated-widget.h"
#include "licensemodel.h"
// #include "activatedetails.h"

// #include "license/settingsgroup.h"
// #include "license/titlevalueitem.h"

#include <QLabel>
#include <QCommandLinkButton>
// #include <QIconButton>

#include <QWidget>

// DWIDGET_USE_NAMESPACE
// using namespace license;

class QGridLayout;
class QPushButton;
class UnactivatedWidget : public QWidget,
                          public Ui::UnactivatedWidget
{
    Q_OBJECT
public:
    enum ActivateType {
        OnlineActivation = 0,
        inlineActivation,
        UKeyActivation
    };

    explicit UnactivatedWidget(QWidget *parent = Q_NULLPTR);
    ~UnactivatedWidget() Q_DECL_OVERRIDE;

    QString getProductSerial();
    void updateView(const LicenseModel &model);
    void initialize();
//    void updateView(const LicenseModel &model);
//    void clearButtonFocus();
//    void changeFontChangeSignal(const bool whetherToConnect);

public slots:
    void changeAcitvateWay(int type);
    void onActivatedBtnClicked();
    void onOfflineBtnClicked();
//    void systemFontSizeChanged(const bool isNeedChangeWidget = true);

signals:
     void importSerialKey(const QString& url, const QString& key);
     void offlineActivateWithOnline();
     void offlineActivateWithInline();
     void activateWithOnline();
     void activateWithInline(const QString& url);


//    void inputSerialClicked();
//    void importLicenseClicked();
//    void tryFullVersionClicked();
//    void activateDetails();

private:
    void initUI();
    void initConnection();

    QString m_ProductSerial;

//    void updateActivateUI();
//    void updateTryFullVersionUI();
//    bool vonderLogoExists();
//    bool kmsServerFileIsActivate();
//    void updateProductID();
//    void updateVersionInfo();
//    void calculateInterfaceSize(const bool &isNeedChangeWidget = true);
//    void autoTestSettingCode();

//    LicenseModel m_model;
//    DLabel *m_customIcon;
//    TitleAuthorizedItem *m_customizedCustomers;
//    TitleValueItem *m_productNameItem;
//    TitleValueItem *m_versionNumberItem;
//    TitleValueItem *m_versionItem;
//    TitleValueItem *m_ActivateStateItem;
//    TitleValueItem *m_licenseStateItem;
//    TitleValueItem *m_ValiditytimeItem;
//    TitleValueItem *m_ValidityDaysItem;
//    TitleValueItem *m_productIDItemItem;
//    DCommandLinkButton *m_trialAndDetailsBtn;
//    QPushButton *m_inputSerialBtn;
//    QPushButton *m_importLicenseBtn;
//    SettingsGroup *m_infoGroup;
//    DIconButton *m_uosLabel;
//    QSpacerItem *m_infoSpace;

//    QDBusInterface *m_interfaceFontChange;
//    QList<TitleValueItem *> m_infoItemList;

    Q_DISABLE_COPY(UnactivatedWidget)
};

#endif // UNACTIVATEDWIDGET_H
