#ifndef HTTPS_H
#define HTTPS_H

#include <QNetworkAccessManager>
#include <QNetworkReply>

class Https : public QObject
{
    Q_OBJECT
public:
    explicit Https(QObject *parent = Q_NULLPTR);
    ~Https();
    void sendPost(const QString &url, const QByteArray &body = "", QString token = "");
    void sendGet(const QString &url, QString token = "");
    void timeOutDeleteReply();

public slots:
    void replyFinished(QNetworkReply *reply);

signals:
    void receiveHttpsData(int httpCode, const QVariantMap &headerDate, const QByteArray &returnData, const QString postName);
    void receiveHealth(const QVariantMap &headerData, int statusCode);

private:
    void updateNetworkReplyList(QNetworkReply *reply);

private:
    QNetworkAccessManager m_manager;
    QString m_previousUrl;
    qint64 m_previousUrlTime = 0;
    QList<QNetworkReply *> m_networkReplyList;
};

#endif // HTTPS_H
