#ifndef KMSTCPCLIENT_H
#define KMSTCPCLIENT_H

#include "kms.h"

#include <QObject>
#include <QByteArray>
#include <QAbstractSocket>

class QTcpSocket;
class KMSTcpClient : public QObject
{
    Q_OBJECT
public:
    explicit KMSTcpClient(QObject *parent = nullptr);
    ~KMSTcpClient();
    bool connectToServer(QString addr, unsigned int port, int timeout = 3000);
    void disconnectServer();
    void sendData(const QJsonObject &obj, const KmsMessageType &messageType);
    QJsonObject recvData();
    bool isConnected();
    void replyFinished();
    qint32 operatorType();

signals:
    void receData();
    void kmsServerError();

public slots:
    void connected();
    void disconnected();
    void connectError(QAbstractSocket::SocketError);

private:
    QTcpSocket *m_tcpClient;
    bool m_connected;
    qint32 m_operateType;
};

#endif // KMSTCPCLIENT_H
