#ifndef LICENSEAGENT_H
#define LICENSEAGENT_H

#include "licensemodel.h"

#include <QDBusAbstractAdaptor>

class LicenseKernel;
class LicenseInfo;
class LicenseAgentPrivate;
class LicenseAgent : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", AGENT_INTERFACE_NAME)

public:
    explicit LicenseAgent(LicenseKernel *kernel, LicenseInfo *licenseInfo, QObject *parent = Q_NULLPTR);
    ~LicenseAgent();
    void loadLicenseFile();

public slots:
    //-------------------------------
    Q_SCRIPTABLE void ImportOnlineSerialA(const QString &online_url, const QString &serial, const QString& product_label);
    Q_SCRIPTABLE void ImportInlineURL(const QString &inline_url, const QString &type);
    Q_SCRIPTABLE void ImportSerialB(const QString &license_b, const QString &product_name, const QString &serial= "");
    //
    //-------------------------------

    //设置自定义激活服务器地址
    Q_SCRIPTABLE void ImportCustomServerUrl(const QString &customServerUrl);
    //设置默认激活服务器地址
    Q_SCRIPTABLE void ImportDefaultServerUrl();
    //获取服务器配置
    Q_SCRIPTABLE QByteArray requestServerConfUrl();

    Q_SCRIPTABLE void ImportStartProductC(const QString &kms_url, const QString &serial, const QString &sn, const QString &note="");

    Q_SCRIPTABLE void ImportStartProductD(const QString &online_url, const QString &type);
private:
    QScopedPointer<LicenseAgentPrivate> dd_ptr;
    Q_DECLARE_PRIVATE_D(qGetPtrHelper(dd_ptr), LicenseAgent)
};

#endif // LICENSEAGENT_H
