#ifndef LICENSEINFO_H
#define LICENSEINFO_H

#include "licensemodel.h"
#include <QNetworkAccessManager>

#include <QObject>

class LicenseKernel;
class LicenseInfo : public QObject
{
    Q_OBJECT
    Q_CLASSINFO("D-Bus Interface", INFO_INTERFACE_NAME)

public:
    LicenseInfo(LicenseKernel *kernel, QObject *parent = Q_NULLPTR);
    ~LicenseInfo();

signals:
    //
    void sendActivateErrorInfo(QString error_info);
    //
    void LicenseStateChange(quint32 operationMseeage = NoOperation);
    void sendActiveMsg(quint32 message, QString startTime);
    void sendServerMsg(quint32 showScene, quint32 code, QVariantMap errData);
    void sendQrcodeUrl(QString qrcodeUrl);
    void heartbeatNotify();
    void errorMessage(quint32 errorMessage);
    void serverReturn(quint32 serverReturn);
    void diagnoseFinishedReturn();

    void show();
    void notify();

    //-------------------------
    void licenseSuccess(QString type);
    void showActivator(const QString &product_label, const QString &product_name, const QString &product_version, bool showProbationPeriod);
    //-------------------------
public slots:
    Q_SCRIPTABLE void Show();
    Q_SCRIPTABLE void Notify();

    Q_SCRIPTABLE QByteArray ProductInfo(QString label);
    Q_SCRIPTABLE void ShowLicenseActivator(const QString &product_label, const QString &product_name, const QString &product_version, bool showProbationPeriod = true);
    Q_SCRIPTABLE QString GetLicenseStatus(const QString &label);
    Q_SCRIPTABLE int GetLicenseState(const QString &type);
    Q_SCRIPTABLE uint GetLicenseExpiration(const QString &type);
    Q_SCRIPTABLE bool check_net_work(const QString &url);
    Q_SCRIPTABLE QString GET_License_B(const QString &type);
private:
    LicenseKernel *m_kernel;
    QNetworkAccessManager* m_pHttpMgr;
};

#endif // LICENSEINFO_HH
