#ifndef LICENSEJSON_H
#define LICENSEJSON_H

#include "https.h"
#include "licensemodel.h"

#include <QObject>
#include <QString>

class SystemInfo;
class LicenseJson : public QObject
{
    Q_OBJECT
public:
    explicit LicenseJson(QObject *parent = Q_NULLPTR);
    ~LicenseJson();
    //解析Json
    QVariantMap parseJsonData(const QJsonDocument &jsonDoc);
    QJsonDocument transQBytearrayToJsonDocument(const QByteArray &byte);
    QString getQrcodeSendStr(const QString &curQrcodeStr);

    // 内网在线激活
    void sendOnlineActivatePublic(const QString &online_url,
                                  const QString &serial,
                                  const QString &mac,
                                  const QString &disk,
                                  const QString &sn,
                                  const QString &product_label);

    void sendOnlineActivatePrivate(const QString &domain_url,
                                   const QString &product_label,
                                   const QString &mac,
                                   const QString &disk,
                                   const QString &sn);

    //获取配置服务器地址
    void getServerUrlConf(QVariantMap map);

    void closeNetworkRequest();

    void sendStartProductC(const QString &kms_url,
                           const QString &serial,
                           const QString &sn,
                           const QString &disk,
                           const QString &mac,
                           const QString &note);

    void sendStartProductD(const QString &react_url,
                           const QString &mac,
                           const QString &sn,
                           const QString &disk,
                           const QString &product_label);

public slots:
    void getServerData(int httpCode, const QVariantMap &headerData, const QByteArray &returnData,
                       const QString &postName);

signals:
    void sendHttpsData(int httpCode, QVariantMap headerData, QVariantMap info, QString postName);

private:
    Https *m_https;
    //服务器地址
    QString m_serverUrlConfig;
    // 内外网在线激活
    QString m_onlinePulicPath;
    QString m_onlinePrivatePath;
    //服务器二维码路径
    QString m_serverQrCodePath;
};

#endif // LICENSEJSON_H
