#include "logencryption.h"

namespace  {
const QByteArray secretKey = "uos-license";
const QByteArray encryptedIdentity = "LogEncryption";
}

QByteArray LogEncryption::encryptionMessage(const QByteArray &data)
{
    if (data.isEmpty())
        return data;

    QByteArray secretData;
    for (auto byte : data) {
        for (auto key : secretKey)
            byte = byte ^ key;
        secretData.append(byte);
    }
    return (encryptedIdentity + secretData.toBase64());
}

QByteArray LogEncryption::encryptionMessage(const QStringList &data)
{
    return encryptionMessage(data.join(",").toLocal8Bit());
}

QByteArray LogEncryption::encryptionMessage(const QString &data)
{
    return encryptionMessage(data.toLocal8Bit());
}

QByteArray LogEncryption::decryptionMessage(const QByteArray &data)
{
    QByteArray decryptData;
    for(auto byte : data) {
        for (int j = (secretKey.length() - 1); j > -1; --j) {
            byte = byte ^ secretKey.at(j);
        }
        decryptData.append(byte);
    }
     return decryptData;
}
