#ifndef MONITORNETWORK_H
#define MONITORNETWORK_H

#include <QGlobalStatic>
#include <QtDBus>
#include <QScopedPointer>

class MonitorNetworkPrivate;
class MonitorNetwork : public QObject
{
    Q_OBJECT
public:
    explicit MonitorNetwork(QObject *parent = Q_NULLPTR);
    ~MonitorNetwork();
    static MonitorNetwork *getInstance();
    void currectNetworkState();
    bool getNetworkState();
    QString getPrimaryConnection();

Q_SIGNALS:
    void networkStateChange(bool isConnected);

public Q_SLOTS:
    void onStateChanged(quint32 state);

private:
    Q_DISABLE_COPY(MonitorNetwork)
    QScopedPointer<MonitorNetworkPrivate> dd_ptr;
    Q_DECLARE_PRIVATE_D(qGetPtrHelper(dd_ptr), MonitorNetwork)
};

#define MONITOR_NETWORK_INSTANCE MonitorNetwork::getInstance()

#endif // MONITORNETWORK_H
